%%%%%%%%%%%%%%%%%%%%%% cp2_5.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/23/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system 
%       example for Comprehensive Problem CP2.5
%----------------------------------------------------
clear, clf
disp('Comprehensive Problem 2.5')
disp('Open-loop response of hydro-turbine system')

hydro  % read data

%  step response of hydro-turbine to q
G = tf(numG,denG)
step(G)
title('CP2.5: Response of Power P to unit Step of Actuator Input u')
grid
keyboard

[r,p,k] = residue(numG,denG)

disp('Note that r(1) is negative')
disp(' ')
disp('*****>'), pause

t = [0:0.07:7]';
disp('Response due to the first pole')
p(1)
y = rpole2t(p(1),r(1),t);
plot(t,y), grid
title('CP2.5: Response due to the first pole')
xlabel('Time (sec)')
ylabel('Amplitude')
keyboard

disp('Response due to the second pole')
p(2)
y = rpole2t(p(2),r(2),t);
plot(t,y), grid
title('CP2.5: Response due to the second pole')
xlabel('Time (sec)')
ylabel('Amplitude')
keyboard

disp('End of Comprehensive Problem 2.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

