%%%%%%%%%%%%%%%%%%%%%% p2_10.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%              last revision: 5/23/99 HS
%----------------------------------------------------
% 		    Problem 2.10: find zeros, poles, gain  
%          of a tf model, and perform PFE.
% Computes impulse response as sum of individual
%       functions and plots impulse response
%----------------------------------------------------
clear, clf
disp('Problem 2.10: Fourth-order system with two repeated poles')
numG = [3 15 12]
denG = [1 5 8.25 5 1]
G = tf(numG,denG)
disp('*****>');pause
GG = zpk(G)
disp('*****>');pause
[zG,pG,kG] = zpkdata(G,'v')
disp('*****>');pause
[resG,polG,otherG] = residue(numG,denG)
disp('*****>');pause
t = [0:0.1:20]';
g1 = rpole2t(polG(1),resG(1),t);
g2 = t.*rpole2t(polG(2),resG(2),t);
g3 = rpole2t(polG(3),resG(3),t);
g4 = t.*rpole2t(polG(4),resG(4),t);
plot(t,g1,'--',t,g2,'-.',t,g3,':',t,g4); grid
title('P2.10: Individual Responses of Repeated Poles (- - and -.-. ; .. and -)')
keyboard
y = impulse(numG,denG,t);
plot(t,y)
grid;title('P2.10: g(t) from G(s) with 2 repeated poles')
xlabel('Time (seconds)')
disp('end of Reinforcement Problem 2.10')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%