%%%%%%%%%%%%%%%%%%%%%% cp3_4.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/25/99 HS
%----------------------------------------------------
%            Comprehensive Problem CP3.4
%       Satellite with lead, plots wheel speed
%	         for ref step response
%----------------------------------------------------
disp('CP3.4: Satellite + lead, plots wheel speed for ref step')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
%
disp('A reasonable value is Klead = -0.001')
Klead = input('enter lead gain (<0) ==>')
Klead_str = num2str(Klead);
disp('A reasonable value is Zlead = -0.02')
Zlead = input('enter lead zero (<0) ==>')
Zlead_str = num2str(Zlead);
disp('A reasonable value is alpha = 20')
Alead = input('enter lead alpha ==>')
Alead_str = num2str(Alead);	
%------ use Eq 3.3 for lead TF
G1 = tf(numG1,denG1)
G2 = tf(numG2,denG2)
numGc = Klead*[1  -Zlead];
denGc = [1  -Alead*Zlead];
Gc = tf(numGc,denGc)
%------- forward transfer function is Gc(s), fdbk is Gp(s)
G_CL = feedback(Gc,G1);
disp('closed-loop zeros, poles & DC gain are:')
[zCL,pCL,kCL]=zpkdata(G_CL,'v')
disp('*******>');pause
%----- connect CL block in series with G2(s)
T = G_CL*G2
disp('zeros, poles & DC gain for theta_des --> wheel speed are:')
[zT,pT,kT]=zpkdata(T,'v')
disp('*******>');pause
t = [0:2:1000]';
y = step(T,t);
plot(t,y);grid
xlabel('Time (secs)'); ylabel('Wheel speed (rpm)')
title('CP3.4: satellite with lead, wheel speed for step in theta_des')
text('Units','Norm','Pos',[0.2 0.25],'String',...
			['Klead = ' Klead_str])
text('Units','Norm','Pos',[0.2 0.15],'String',...
			['Zlead = ' Zlead_str])
text('Units','Norm','Pos',[0.2 0.05],'String',...
			['Alead = ' Alead_str])
disp('end of Comprehensive Problem 3.4')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
