%%%%%%%%%%%%%%%%%%%%%% cp3_5b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/25/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system  
%      example for Comprehensive Problem CP3.5b
%----------------------------------------------------
clear, clf
disp('Comprehensive Problem 3.5b')
disp('Lead controller design for hydro-turbine system')

hydro  % read data
disp('*****>'), pause

disp(' ')
disp('Lead controller with zero at s = -3 and alpha = 20')
disp('Klead = 10 gives a good response')
disp('... However, you will get large under-shoot also.')
Klead = input('enter controller gain Klead ==> ');
z = -3
G = tf(numG,denG)
numlead = Klead*[1  -z];
denlead = [1  -20*z];
Glead = tf(numlead,denlead)
H_OL = Glead*G

disp('Closed-loop system transfer functin ')
T = feedback(H_OL,1)
[numT,denT] = tfdata(T,'v')
disp('*****>'), pause

disp('Poles of closed-loop system')
pT = roots(denT)
disp('Zeros of closed-loop system')
zT = roots(numT)
disp('DC gain of closed-loop system')
DC_gain = dcgain(numT,denT)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP3.5b: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('end of Comprehensive Problem 3.5b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

