%%%%%%%%%%%%%%%%%%%%% wif3_5.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/2/99 HS
%----------------------------------------------------
%	        What If for Example 3.5:
%       Gain variation in 2-input feedback system
%----------------------------------------------------
clear,clf
  disp('WhatIf? 3.5: ')
  disp('Controller gain variation in feedback system')
  disp('   with reference & disturbance inputs')
  disp('----------------------------')
%
kGc = input('Enter controller gain (80 - same as Ex. 3.5) ==>')
disp('Numerator & denominator of lead controller transfer function')
numGc =kGc*[1 3]		% numerator of lead controller
denGc = [1 15*3]	% denominator "  "     "
Gc = tf(numGc,denGc)
disp('*******>');pause
disp('Numerator & denominator of plant transfer function')
numGp = 4		% numerator of plant
denGp = conv([0.5 1],[2 1])	% denominator of plant
Gp = tf(numGp,denGp)
disp('*******>');pause
disp('Numerator & denominator of sensor transfer function')
num_sen = 1		% numerator of sensor
den_sen = [0.05 1]	% denominator of sensor
Gsen = tf(num_sen,den_sen)
disp('*******>');pause
%------ G & H for reference input
G_ref = Gc*Gp
[numG_ref denG_ref] = tfdata(G_ref,'v')
disp('*******>');pause
numH_ref = num_sen
denH_ref = den_sen
H_ref = tf(num_sen,den_sen)
disp('*******>');pause
%---------- open-loop transfer function for reference input
numGH_ref = conv(numG_ref,numH_ref)
denGH_ref = conv(denG_ref,denH_ref)
GH_ref = tf(numGH_ref,denGH_ref)
  disp('*******>');pause
disp('open-loop zeros & poles for reference input')
zGH = tzero(GH_ref)
pGH = pole(GH_ref)
  disp('*******>');pause
%------------- closed-loop step response to reference input
CL_ref = feedback(G_ref,H_ref,-1)
  disp('*******>');pause
disp(' closed-loop zeros & poles for reference input')
zCL_ref = tzero(CL_ref)
pCL_ref = pole(CL_ref)
  disp('*******>');pause
t = [0:0.01:2];
y_ref = step(CL_ref,t);
%=========== repeat for disturbance input ===========
disp('For disturbance input, fwd path = plant')
disp('... & fdbk path = controller * -1 * sensor')
  disp('*******>');pause
disp('forward-path transfer function')
numG_dist = numGp
denG_dist = denGp
G_dist = tf(numG_dist,denG_dist)
disp('*******>');pause
H_dist = -Gc*Gsen
[numH_dist, denH_dist] = tfdata(H_dist,'v')
disp('*******>');pause
%---------- open-loop transfer function for disturbance input
disp('open-loop transfer function for disturbance input')
numGH_dist = conv(numG_dist,numH_dist)
denGH_dist = conv(denG_dist,denH_dist)
GH_dist = tf(numGH_dist,denGH_dist)
  disp('*******>');pause
disp('open-loop zeros & poles for disturbance input')
zGH_dist = tzero(GH_dist)
pGH_dist = pole(GH_dist)
  disp('*******>');pause
%------------- closed-loop step response to disturbance input
%--- use +1 for feedback gain because neg sign is in H(s)
CL_dist = feedback(G_dist,H_dist,+1)
disp('*******>');pause
disp('closed-loop zeros & poles for disturbance input')
zCL_dist = tzero(CL_dist)
pCL_dist = pole(CL_dist)
y_dist = step(CL_dist,t);
%-------- plot both responses
plot(t,y_ref,t,y_dist,'--');grid
xlabel('Time (s)'),ylabel('output')
text(0.5,0.5,['Controller gain = ' num2str(kGc)])
title('WIF3.5: CL ref & dist step responses,lead control')
disp('end of What If 3.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
