%%%%%%%%%%%%%%%%%%%%%% cp6_2.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%            Comprehensive Problem CP6.2
%   open-loop satellite frequency response plots
%   using TF from motor torque --> pointing angle
%   Need small negative gain to get reasonable values
%   	so use Kc = -0.001
%Note: must adjust axis values to get informative plots
%----------------------------------------------------
disp('CP6.2: OL satellite: frequency response')
clear,clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
G1 = tf(numG1,denG1)
bode(G1)
title('CP6.2: OL satellite: motor torque --> theta; Kc = +1')
disp('Bode plot with positive gain gives bad phase values')
disp('....so will try negative gain')
keyboard
%--------
bode(-G1)
title('CP6.2: OL satellite: motor torque --> theta; Kc = -1')
disp('negative gain is OK, but need lower gain for')
disp('.....reasonable phase margin values')
keyboard
%--------
Kc = -0.001
margin(Kc*G1)
text(0.0002,-60,'OL satellite: motor torque --> theta')
text(0.0002,-80,'Kc = -0.001')
subplot(111)
disp('Bode plot with small negative gain looks reasonable')
keyboard
%--------
disp('Nyquist plot requires careful choice of plotting area')
clf
nyquist(Kc*G1);grid
title('CP6.2: OL satellite: motor torque --> theta; Kc = -0.001')
axis('equal')
keyboard
disp('redrawing Nyquist plot with smaller area')
axis([-500 500 -300 300])
keyboard
disp('redrawing Nyquist plot with smaller area')
axis([-50 10 -30 30])
keyboard
disp('redrawing Nyquist plot with smaller area')
axis([-5 1 -3 3])
keyboard
%--------
disp('for Nichols plot, use axis to keep magnitudes from')
disp('..... getting  too large or too small, & restrict phase')
nichols(Kc*G1)
grid
axis([-200 0 -40 40])
title('CP6.2: OL satellite: motor torque --> theta')
text(-80,-25,'Kc = -0.001')
disp('end of Comprehensive Problem 6.2')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
