%%%%%%%%%%%%%%%%%%%%%% cp6_3.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28//99 HS
%----------------------------------------------------
%            Comprehensive Problem CP6.3
% open-loop rigid stick balancer frequency response 
% plots using TF from motor torque --> pointing angle
% Note: must adjust axis values to get 
%       informative plots
%----------------------------------------------------
clear;clf
% load rigid.mat if exists, otherwise quit this M-file
if chkmat('rigid') == 1, 
    load rigid.mat
  else
     return
end
%--- 
disp('CP6.3: Stick balancer with riged stick has')
disp('TF from motor torque --> pointing angle has')
disp('   two zeros at s=0, one pole at s=0, & 1 RHP pole')
G1 = tf(numG1,denG1)
bode(G1)
title('CP6.3: OL rigid stick balancer, TF from u(t) --> theta')
disp('Hence, its Bode plots will look rather unusual.')
keyboard
nyquist(G1);grid
axis([-.01 .01 -.02 .02])
title('CP6.3: OL rigid stick balancer, TF from u(t) --> theta')
disp('Nyquist plot')
keyboard
nichols(G1);grid
title('CP6.3: OL rigid stick balancer, TF from u(t) --> theta')
disp('Nichols plot')
disp('end of Comprehensive Problem 6.3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
