%%%%%%%%%%%%%%%%%%%%%% p6_1.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%       Problem 6.1: simulate response due to 
%    sinusoidal input. Compute frequency response.
%----------------------------------------------------
  clear,clf
  disp('Problem 6.1: Single-frequency input signal')
  disp(' ')
  disp('Enter transfer-function coefficients')
  numG = [2 3 4]
  denG = [1 2 2.5 0.5]
  G = tf(numG,denG)
  disp('*****>');pause
  disp('Setting up t, u and y')
  t = [0:0.06:20]'; % time vector with 0.06 sec. increment
  u = 4*cos(2*t - 60*pi/180);  
  y = lsim(G,u,t);
  disp('magnitude and phase of frequency response at w = 2 rad/s')
  [mag,phase] = bode(G,2)  
  disp('*****>');pause
  disp('magnitude and phase of steady-state response')
  y_mag = 4 * mag
  y_phase = -60 + phase
  y_ss = y_mag*cos (2*t + (y_phase)*pi/180);
  plot(t,u,'-',t,y,'--',t,y_ss,'-.')
  grid, title('P6.1 : u (solid), y (dashed) & yss (dashdot)')
  xlabel('Time in seconds')
  ylabel('u, y, yss')
  keyboard
  disp('end of Reinforcement Problem 6.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%