%%%%%%%%%%%%%%%%%%%%%% p7_4.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%          Problem 7.4: find Kp and Kv, and 
%          simulate step and ramp responses
%----------------------------------------------------
clear,clf
  disp('Problem 7.4: Steady-state regulation')
  disp('  Find Kp and Kv, and simulate step and')
  disp('  ramp responses')
  disp(' ')
  numGp = 6*[1 10]                         	% generate G(s)
  denGp = conv([1 3],[1 4 4]) 
  Gp = tf(numGp,denGp)
  disp('*****>');pause
  G = 3*Gp										      % compensated system
  Kp = dcgain(G)                   			   % position error constant
  disp('*****>');pause
  Kv = vgain(G)                    			   % velocity error constant
  disp('*****>');pause
  disp('Close system loop and see step response')
  T = feedback(G,1)         					  % closed-loop system
  t = [0:0.05:20]';
  ystep = step(T,t);       					 % step response
  plot(t, [ones(size(t)) ystep])
  title('P7.4: Step response')
  xlabel('time in seconds')
  ylabel('response')
  grid
  keyboard
  disp('See ramp response')
  t = [0:0.05:40]'; u = t;                  % time and unit ramp
  yramp = lsim(T,u,t);         				  % ramp response
  plot(t,[t yramp])
  title('P7.4: Ramp response')
  xlabel('time in seconds')
  ylabel('response')
  grid
  keyboard
  disp('end of Reinforcement Problem 7.4')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%