%%%%%%%%%%%%%%%%%%%%%% p7_6.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%     Problem 7.6: frequency response performance
%           Bandwidth, gain & phase margins
%----------------------------------------------------
  clear,clf
  disp('Problem 7.6: Frequency response performance')
  disp('             Bandwidth, gain & phase margins')
  disp(' ')
  numGp = [1 5]                             % generate Gp(s)
  denGp = [1 13 12]
  Gp = tf(numGp,denGp)
  numH = 60
  denH = conv([1 3],[1 20])                % generate H
  H = tf(numH,denH)
  disp('*****>');pause
  Gcp = 15*Gp
  GcpH_OL = Gcp*H
  margin(GcpH_OL)                		    % gain & phase margins
  grid
  keyboard
  disp('transfer function T(s)')
  Tr = feedback(Gcp,H) 							% T(s)
  bode(Tr)
  title('P7.6: transfer function T(s) frequency response')
  keyboard
  disp('Computing bandwidth from T(jw)')
  [mag_CL,ph_CL,w] = bode(Tr);  % frequency response
  mag_CLdB = 20*log10(mag_CL);             % gain in dB
  lfg_CL = dcgain(Tr)           % dc gain
  lfg_CL_dB = 20*log10(lfg_CL)
  BW = bwcalc(mag_CLdB,w,lfg_CL)           % bandwidth
  [M_pw,i] = max(mag_CLdB)                 % maximum freq. resp.
  wp = w(i)                                
  disp('*****>');pause
  S = feedback(1,GcpH_OL)						 % S(s)
  [magS,phS] = bode(S,w);                  % sensitivity
  magS_dB = 20*log10(magS);
  [maxS,j] = max(magS_dB)						 % maximum sensitivity magnitude
  w(j)
  semilogx(w,mag_CLdB(:),'-',w,magS_dB(:),'--'), grid
  xlabel('Frequency (rad/sec)')
  ylabel('Gain dB')
  text(20,5,'|T(jw)|')
  text(20,-40,'|S(jw)|')
  title('P7.6: sensitivity function S(s) frequency response')
  keyboard
  disp('damping ratios')
  damp(Tr)
  disp('*****>');pause
  t = [0:0.05:5]';
  y = step(Tr,t);
  clf, plot(t,y); grid
  ylabel('amplitude');xlabel('Time (sec)')
  title('P7.6: Step response of closed-loop system')
  [mo,tp,tr,ts,ess] = tstats(t,y,1.0);
  text(1,0.40,['overshoot = ' num2str(mo) ' %'])
  text(1,0.35,['time to overshoot = ' num2str(tp) ' s'])
  text(1,0.30,['rise time = ' num2str(tr)])
  text(1,0.25,['2pct settling time = ' num2str(ts)])
  text(1,0.20,['steady-state error = ' num2str(ess) ' %'])
  keyboard
  disp('end of Reinforcement Problem 7.6')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

