%%%%%%%%%%%%%%%% fig8_6b.m %%%%%%%%%%%%%%%
%
%      2nd order plant with 2 real poles with PID control
%	Does parameter sweep on KP with specified values
%	 of KI and KD
%  	Jan 99
%   last revision:  1/6/99  JHC
%----------------------------------------
clear; clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 8.6(b): PID control')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
numGp = Kproc;
denGp = conv([tauP1 1],[tauP2 1]);
H     =tf(1,[tau_sen 1]);
KI = 0.5;
KD = 0.4;
KI_str=num2str(KI);
KD_str=num2str(KD);
denGc = [1 0];
denG = conv(denGc,denGp);
%----- CL step response to reference input
t = [0:0.01:2]';
  for KP = [1:1:10];
    numKc = KP*[KD 1 KI];   % numerator of PID controller
    numGK = conv(numKc,numGp);
    GK = tf(numGK,[denGp 0])
    T = feedback(GK,H,-1);
    ys = step(T,t);
    plot(t,ys)
    if ishold ~=  1, hold on, end
end	% of 'for'
hold off
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
% title('fig 8.6(b): CL step response, PID control, ref input')
text(1.0,0.35,'KP = 1,2,3,...,10')
text(1.0,0.25,['KI = ' KI_str])
text(1.0,0.15,['KD = ' KD_str])
text(0.18,1.22,'KP = 10')
text(0.7,0.65,'KP = 1')
print -deps fig8_6b.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%