%%%%%%%% fig9_10.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.10: Bode plots for Example 9.4')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]))
H  = tf(1,[tau_sen 1])
GpH = Gp*H
%-------- final lead-lag design
Kldlg = 100; Zlead = -6.433; Alead = 25.66;
Zlag = -0.3379; Alag = 33.21;
%----------
w = logspace(-3,3,100);
ph180 = -180*ones(length(w));
%----- first do gain-only
[mag_K,ph_K] = bode(Kldlg*GpH,w);
mag_K = reshape(mag_K,100,1);
ph_K  = reshape(ph_K, 100,1);
mag_db_K = 20*log10(mag_K);
%
%-------- do calcs with final lead-lag design
Glead = tf(Alead*[1  -Zlead],[1  -Alead*Zlead]);
Glag  = tf([-1/Zlag  1],[-Alag/Zlag  1]);
[mag_ldlg,ph_ldlg] = bode(Kldlg*Glead*Glag*GpH,w);
mag_ldlg = reshape(mag_ldlg,100,1);
ph_ldlg  = reshape(ph_ldlg, 100,1);
mag_db_ldlg = 20*log10(mag_ldlg);
%--------- now plot both sets
subplot(211)
semilogx(w,mag_db_ldlg,w,mag_db_K,'--');grid;
xlabel('Frequency (rad/sec)')
ylabel('Gain dB')
% title('fig 9.10: lead-lag design for Ex. 9.4')
axis([0.001 1000 -100 75])
text(1.5,-30,'Lead-lag')
text(20,10,'Proportional')
subplot(212)
semilogx(w,ph_ldlg,'-',w,ph_K,'--',w,ph180,':');
grid
axis([0.001 1000 -300 25])
xlabel('Frequency (rad/sec)')
ylabel('Phase deg')
text(20,-130,'Lead-lag')
text(0.5,-230,'Proportional')
print -deps fig9_10.eps
subplot(111)	% reset plot window
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%