%%%%%%%%%%%%%%%% fig9_13.m %%%%%%%%%%%%%%%
%
%      2nd order plant with 2 real poles with
%		 LEAD-LAG control
%	Does parameter sweep on Kllag 
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.13: Lead-lag control with gain sweep, Ex. 9.5')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]))
H  = tf(1,[tau_sen 1])
%---- specify controller except gain
Alpha = 20; Zlag = -0.691; Zlead = -1.809;
Alpha_str = num2str(Alpha);
Zlag_str = num2str(Zlag);
Zlead_str = num2str(Zlead);
numldlg = conv([1 -Zlag],[1 -Zlead]); % lead-lag without gain
denldlg = conv([1 -Zlag/Alpha],[1 -Alpha*Zlead]); 
G_ldlg  = tf(numldlg,denldlg)
%------------- closed-loop step response to reference input
t = [0:0.005:1];
for Kldlg = [40:10:120];
  T  = feedback(Gp*Kldlg*G_ldlg,H,-1);
  ys = step(T,t);
  plot(t,ys)
  if ishold ~=  1, hold on, end
end
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
% title('fig 9.13: CL step resp,lead-lag, Ex. 9.5')
text(0.5,0.35,'Kldlg = 40, 50,...,120')
text(0.5,0.25,['Zlag = ' Zlag_str])
text(0.5,0.15,['Zlead = ' Zlead_str])
text(0.5,0.05,['Alpha = ' Alpha_str])
text(0.24,1.35,'Kldlg = 120')
text(0.24,0.65,'Kldlg = 40')
print -deps fig9_13.eps
hold off
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%