%%%%%%%%%%%%%%%% fig9_7.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.7: Lag control via Kuo''s algorithm ')
%----- plant parameters
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4; 
Klag = 12.25;
Zlag = -0.1572;
Alag = 11.64;
Klag_str=num2str(Klag);	
Alag_str = num2str(Alag);
Zlag_str = num2str(Zlag);
%------
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]));
H  = tf(1,[tau_sen 1]);
Gc = tf(Klag*[-1/Zlag  1],[-Alag/Zlag  1]);	 
%------ reference input
T_ref = feedback(Gp*Gc,H,-1)
t = [0:0.02:10];
y_ref = step(T_ref,t);
%=========== repeat for disturbance input ===========
T_dist = feedback(Gp,-Gc*H,+1)
y_dist = step(T_dist,t);
%
%-------- plot both responses
plot(t,y_ref,t,y_dist,'--')
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
%title('fig 9.7: CL ref & dist step resp,lag, Ex. 9.2')
text(7.0,0.75,['Klag = ' Klag_str])
text(7.0,0.68,['Zlag = ' Zlag_str])
text(7.0,0.61,['Alag = ' Alag_str])
text(6.0,0.98,'reference')
text(3.0,0.42,'disturbance')
axis([0 10 0 1.2])
print -deps fig9_7.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%