%%%%%%%%%%%%%%%% fig9_9.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 9.9: Lead control via Kuo''s algorithm ')
%----- plant parameters
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4; 
%---- final lead design
Klead = 6; Zlead = -1.995; Alead = 27.52;
Klead_str = num2str(Klead);
Alead_str = num2str(Alead);
Zlead_str = num2str(Zlead);
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]))
H  = tf(1,[tau_sen 1])
GpH = Gp*H
Klead = 6; Zlead = -1.995; Alead = 27.52;
Gc = tf(Klead*Alead*[1  -Zlead],[1  -Alead*Zlead]);

%==========  CL step responses for Fig. 9.9 =====
%---  reference input: fwd path = Gc*Gp;  fdbk path = H
T_ref = feedback(Gp*Gc,H,-1)
t = [0:0.005:2];
y_ref = step(T_ref,t);

%=========== repeat for disturbance input ===========
%--- dist input: fwd path = Gp; fdbk path = -H*Gc
T_dist = feedback(Gp,-Gc*H,+1)
y_dist = step(T_dist,t);
%
%-------- plot both responses
plot(t,y_ref,t,y_dist,'--')
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
%title('fig 9.9: CL ref & dist step resp,lead, Ex. 9.3')
text(1.4,0.75,['Klead = ' Klead_str])
text(1.4,0.68,['Zlead = ' Zlead_str])
text(1.4,0.61,['Alead = ' Alead_str])
text(1.0,1.00,'reference')
text(0.7,0.19,'disturbance')
axis([0 2 0 1.2])
print -deps fig9_9.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%